Debian Bug report logs - #620589
sbuild: option to turn off log filtering

version graph

Package: sbuild; Maintainer for sbuild is Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>; Source for sbuild is src:sbuild.

Reported by: Jakub Wilk <jwilk@debian.org>

Date: Sat, 2 Apr 2011 23:21:02 UTC

Severity: wishlist

Tags: fixed-upstream

Found in version sbuild/0.62.1-1

Fixed in version sbuild/0.62.2-1

Done: Roger Leigh <rleigh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, jwilk@debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#620589; Package sbuild. (Sat, 02 Apr 2011 23:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
New Bug report received and forwarded. Copy sent to jwilk@debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. (Sat, 02 Apr 2011 23:21:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: sbuild: option to turn off log filtering
Date: Sun, 3 Apr 2011 01:17:20 +0200
Package: sbuild
Version: 0.62.1-1
Severity: wishlist

Please add an option to turn off log filtering. Thanks in advance.

(To be honest, I don't understand why you decided to cripple logs with 
this "feature"...)

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#620589; Package sbuild. (Sun, 03 Apr 2011 00:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. (Sun, 03 Apr 2011 00:36:04 GMT) Full text and rfc822 format available.

Message #10 received at 620589@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Jakub Wilk <jwilk@debian.org>, 620589@bugs.debian.org
Cc: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Re: [buildd-tools-devel] Bug#620589: sbuild: option to turn off log filtering
Date: Sun, 3 Apr 2011 01:26:08 +0100
[Message part 1 (text/plain, inline)]
On Sun, Apr 03, 2011 at 01:17:20AM +0200, Jakub Wilk wrote:
> Package: sbuild
> Version: 0.62.1-1
> Severity: wishlist
> 
> Please add an option to turn off log filtering. Thanks in advance.

That's no problem.

> (To be honest, I don't understand why you decided to cripple logs
> with this "feature"...)

Some people complained that build logs couldn't be diffed easily due
to the random part in the build directory name (which the filtering
makes constant).


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#620589; Package sbuild. (Sun, 03 Apr 2011 23:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. (Sun, 03 Apr 2011 23:09:05 GMT) Full text and rfc822 format available.

Message #15 received at 620589@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 620589@bugs.debian.org
Subject: Re: [buildd-tools-devel] Bug#620589: sbuild: option to turn off log filtering
Date: Mon, 4 Apr 2011 00:41:28 +0200
* Roger Leigh <rleigh@codelibre.net>, 2011-04-03, 01:26:
>>Please add an option to turn off log filtering. Thanks in advance.
>That's no problem.

Thanks.

>>(To be honest, I don't understand why you decided to cripple logs with 
>>this "feature"...)
>
>Some people complained that build logs couldn't be diffed easily due
>to the random part in the build directory name (which the filtering
>makes constant).

Yes, I stumbled on this problem a few times, too. But:

1. If you diff logs only ocasionally, you can easily fix the problem 
locally. Just use search&replace function in your $EDITOROFCHIOCE. Or 
write a <50 lines post-processing script in your $LANGUAGEOFCHOICE.

2. If you diff logs on large scale, you need the current sbuild's log 
filtering is too naïve: there are other sources of diff noise, which 
sbuild cannot always fix without losing information (e.g.  
aptitude/apt-get/dpkg output). So one would up with writing a 
(sophisticated) log post-processor anyway.

3. sbuild _do_ lose information even now, because strings like CHROOT 
and BUILDDIR can occur naturally in a build log. See e.g.:
https://buildd.debian.org/fetch.cgi?pkg=stunnel4&arch=ia64&ver=3:4.29-1&stamp=1260333411&file=log

4. If want copy&paste filtered log snippets and send them to other 
people, I need to either undo the filtering (which cannot be done fully 
automatically, see 3.) or write an extra explanation about the 
transformation that were done. This is completely unnecessary burden.

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#620589; Package sbuild. (Mon, 04 Apr 2011 17:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. (Mon, 04 Apr 2011 17:27:04 GMT) Full text and rfc822 format available.

Message #20 received at 620589@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 620589@bugs.debian.org, Jakub Wilk <jwilk@debian.org>
Subject: Re: [buildd-tools-devel] Bug#620589: Bug#620589: sbuild: option to turn off log filtering
Date: Mon, 4 Apr 2011 18:22:47 +0100
[Message part 1 (text/plain, inline)]
tags 620589 + fixed-upstream pending
thanks

On Mon, Apr 04, 2011 at 12:41:28AM +0200, Jakub Wilk wrote:
> * Roger Leigh <rleigh@codelibre.net>, 2011-04-03, 01:26:
> >>Please add an option to turn off log filtering. Thanks in advance.
> >That's no problem.
> 
> Thanks.

Now done.  You can set $log_filter = 0; in sbuild.conf/.sbuildrc
to disable it.

> >>(To be honest, I don't understand why you decided to cripple
> >>logs with this "feature"...)
> >
> >Some people complained that build logs couldn't be diffed easily due
> >to the random part in the build directory name (which the filtering
> >makes constant).
> 
> Yes, I stumbled on this problem a few times, too. But:
> 
> 1. If you diff logs only ocasionally, you can easily fix the problem
> locally. Just use search&replace function in your $EDITOROFCHIOCE.
> Or write a <50 lines post-processing script in your
> $LANGUAGEOFCHOICE.
> 
> 2. If you diff logs on large scale, you need the current sbuild's
> log filtering is too naïve: there are other sources of diff noise,
> which sbuild cannot always fix without losing information (e.g.
> aptitude/apt-get/dpkg output). So one would up with writing a
> (sophisticated) log post-processor anyway.

I absolutely agree; total consistency between builds is probably
impossible to achieve, and we also put things like the date,
package versions etc. in there which will generally be changing.

There was a particular complaint about the variability and long
paths (the length may be more legitimate).  I implemented the
filtering as a solution to that.  Note that the filtering mechanism
is extensible to replacing any fixed pattern with a replacement,
so it can be extended to other strings as well if required.

> 3. sbuild _do_ lose information even now, because strings like
> CHROOT and BUILDDIR can occur naturally in a build log. See e.g.:
> https://buildd.debian.org/fetch.cgi?pkg=stunnel4&arch=ia64&ver=3:4.29-1&stamp=1260333411&file=log

This is a good point.  I know it's not totally foolproof, but I added
guillemots to the replacement text:

I: NOTICE: Log filtering will replace 'build/dadadodo-Zu8Yd5' with '«BUILDDIR»'
I: NOTICE: Log filtering will replace 'var/lib/schroot/mount/sid-amd64-sbuild-0f09fbd2-17fb-43c0-99e4-5b2cc5fbfa4d' with '«CHROOT»'
…
/usr/bin/make clean
make[1]: Entering directory `/«BUILDDIR»/dadadodo-1.04'
rm -f *.o a.out core dadadodo
make[1]: Leaving directory `/«BUILDDIR»/dadadodo-1.04'
 dpkg-source -b dadadodo-1.04

If you've got a better choice of replacement character, I can change it
--it's just not that widely used, and so means you can revert the
replacement a lot more reliably than without.

> 4. If want copy&paste filtered log snippets and send them to other
> people, I need to either undo the filtering (which cannot be done
> fully automatically, see 3.) or write an extra explanation about the
> transformation that were done. This is completely unnecessary
> burden.

True; hopefully turning it off with the above change will be OK for
you?

Note that the existing two replacements should not impact on the
utility of logs since they are build-specific paths which are not
reproducible.  The only time you would need to care about them is
if you are debugging a bug in sbuild itself if it's using the wrong
paths, or you need to examine a broken build, in which case you'll
have the needed information (location) right at the top of the log.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending and fixed-upstream. Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Mon, 04 Apr 2011 17:27:06 GMT) Full text and rfc822 format available.

Reply sent to Roger Leigh <rleigh@debian.org>:
You have taken responsibility. (Tue, 05 Apr 2011 10:08:33 GMT) Full text and rfc822 format available.

Notification sent to Jakub Wilk <jwilk@debian.org>:
Bug acknowledged by developer. (Tue, 05 Apr 2011 10:08:36 GMT) Full text and rfc822 format available.

Message #27 received at 620589-close@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: 620589-close@bugs.debian.org
Subject: Bug#620589: fixed in sbuild 0.62.2-1
Date: Tue, 05 Apr 2011 10:04:21 +0000
Source: sbuild
Source-Version: 0.62.2-1

We believe that the bug you reported is fixed in the latest version of
sbuild, which is due to be installed in the Debian FTP archive:

buildd_0.62.2-1_all.deb
  to main/s/sbuild/buildd_0.62.2-1_all.deb
libsbuild-perl_0.62.2-1_all.deb
  to main/s/sbuild/libsbuild-perl_0.62.2-1_all.deb
sbuild_0.62.2-1.debian.tar.gz
  to main/s/sbuild/sbuild_0.62.2-1.debian.tar.gz
sbuild_0.62.2-1.dsc
  to main/s/sbuild/sbuild_0.62.2-1.dsc
sbuild_0.62.2-1_amd64.deb
  to main/s/sbuild/sbuild_0.62.2-1_amd64.deb
sbuild_0.62.2.orig.tar.gz
  to main/s/sbuild/sbuild_0.62.2.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 620589@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Roger Leigh <rleigh@debian.org> (supplier of updated sbuild package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: RIPEMD160

Format: 1.8
Date: Tue, 05 Apr 2011 10:46:49 +0100
Source: sbuild
Binary: libsbuild-perl sbuild buildd
Architecture: source all amd64
Version: 0.62.2-1
Distribution: unstable
Urgency: low
Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
Changed-By: Roger Leigh <rleigh@debian.org>
Description: 
 buildd     - Daemon for automatically building Debian binary packages from Deb
 libsbuild-perl - Tool for building Debian binary packages from Debian sources
 sbuild     - Tool for building Debian binary packages from Debian sources
Closes: 619002 619128 619288 619332 619416 619526 620112 620589 620758 620797
Changes: 
 sbuild (0.62.2-1) unstable; urgency=low
 .
   * New release.
   * sbuild:
     - New options --no-apt-clean, --no-apt-update, --no-apt-upgrade and
       --no-apt-distupgrade have been added to allow these actions to be
       disabled even when set as the default in the configuration.
     - root is not required to be a member of the sbuild group in order
       to run schroot via the sbuild-schroot wrapper
       (Closes: #619128, #619002).
     - Don't require HOME to be set in the environment (Closes: #619288).
     - Work around broken build-essential on Ubuntu Lucid
       (Closes: #619526).  Thanks to Marc Deslauriers.
     - --keep-session is replaced by
       --purge-session=(always|successful|never).  This will allow the
       session to be purged for all, successful and no builds,
       respectively (Closes: #619332).
     - sources.list fragments stored in /etc/apt/sources.list.d have
       0644 permissions, so that normal users can run apt-cache in the
       chroot during a build (Closes: #620797).  Thanks to Julian Andres
       Klode for identifying this problem.
     - Log filtering may be disabled using $log_filter = 0 in the
       configuration (Closes: #620589).  The replacement text is now
       also surrounded with "«" and "»" so that strings such as CHROOT
       and BUILDDIR can't be confused with any actual appearance of the
       same string in the build log.
     - Log colouring may be disabled using $log_colour = 0 in the
       configuration.
     - Improve binNMU handling to permit binNMUs for multiarch packages
       (Closes: #620112).  Currently, binary NMUs use the current date
       in the new changelog entry, but co-installable packages require
       an identical changelog.  To avoid this, take the date from the
       previous changelog entry to ensure the same date for all binNMUs.
       Thanks to Anders Kaseorg for this patch.
     - Abort early if maintainer is not defined when performing a binNMU
       or appending a version suffix (Closes: #620758).
   * sbuild.conf:
     - Don't set a default value for $build_dir (Closes: #619416).
       This value is set each run, and so varies between builds when
       generating the configuration file.  Exclude from the generated
       output to prevent unnecessary differences between builds.
     - $purge_session uses the same purge modes as $purge_build_deps and
       $purge_build_directory, rather than a boolean value.
   * buildd:
     - Merge latest changes from buildd-0.61.0.
Checksums-Sha1: 
 23a5db34143a03b7251ae6440ab9ca4631ae72e6 1420 sbuild_0.62.2-1.dsc
 d4cc410d1235521e08b9c99666ae58316230cf5f 543829 sbuild_0.62.2.orig.tar.gz
 08e9a26440ca4d6cf9db0a87893910482d1fc4b4 50929 sbuild_0.62.2-1.debian.tar.gz
 e8c430b39f86e1972b50c976cd89c4ab58eaffef 273026 libsbuild-perl_0.62.2-1_all.deb
 24aeae499fc53b5674eaf23b12e35dc4e266c816 271330 buildd_0.62.2-1_all.deb
 5aa33d053c9dfadb4c925e34dfc70da353b83779 293108 sbuild_0.62.2-1_amd64.deb
Checksums-Sha256: 
 e6e079147dbfb0511f745261813745143fb5f01871bca8cadd48651dd5dec47b 1420 sbuild_0.62.2-1.dsc
 d8b745e694b1508c8584aefb60fc70743999d4967bcdfd0cdf916de452d30cfb 543829 sbuild_0.62.2.orig.tar.gz
 19c58f50dc38ad70137077c11035e2ba742dfc6f4b6782d539a348c165ed11e8 50929 sbuild_0.62.2-1.debian.tar.gz
 9579baf220ea6b8bdfae98251b5c5fef06c2640d373e9696723146357e6a7767 273026 libsbuild-perl_0.62.2-1_all.deb
 92ffeac5b86b1d1eacbb1c9cebd0d020ee4e8bdb37047d8715a0a5d7cf4d62e5 271330 buildd_0.62.2-1_all.deb
 9e80c678c4e448a2ef7293049b2797206e208f38cb88765631075cbd08ef5b0f 293108 sbuild_0.62.2-1_amd64.deb
Files: 
 a999ec153ccbb042ba36828bc23bd191 1420 devel extra sbuild_0.62.2-1.dsc
 cbd48939c95c749fb20bd0ec7c8010dd 543829 devel extra sbuild_0.62.2.orig.tar.gz
 b8e9530aa7734b933678efb04bd202bf 50929 devel extra sbuild_0.62.2-1.debian.tar.gz
 48f0689c07207c79238aff466f73606a 273026 perl extra libsbuild-perl_0.62.2-1_all.deb
 f7df2abe665925094cff140e7ce8f8e5 271330 devel extra buildd_0.62.2-1_all.deb
 6e1cb72b2779b8a6048e215e70cc285a 293108 devel extra sbuild_0.62.2-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEAREDAAYFAk2a5sgACgkQVcFcaSW/uEijqwCdHfb66ME6V7MeFfGxDdZMIy6H
UzkAoIfguBLPecrNK1mWgNO7g7XhtItk
=Y5fn
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 17 May 2011 08:03:47 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 07:26:39 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.